#include <stdio.h>

extern struct rtpkt {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int mincost[4];    /* min cost to node 0 ... 3 */
  };

extern int TRACE;
extern int YES;
extern int NO;

struct distance_table 
{
  int costs[4][4];
} dt2;


/* students to write the following two routines, and maybe some others */

static int update_flag = 0;
static int stored_mincost[4] = {999, 999, 999, 999};

void rtinit2() 
{
  struct rtpkt packet;
  struct distance_table *dtptr;

  dt2.costs[0][0] = 3;
  dt2.costs[1][1] = 1;
  dt2.costs[3][3] = 2;
  dt2.costs[0][1] = 999;
  dt2.costs[0][3] = 999;
  dt2.costs[1][0] = 999;
  dt2.costs[1][3] = 999;
  dt2.costs[3][0] = 999;
  dt2.costs[3][1] = 999;
  packet.sourceid = 2;
  packet.destid = 0;
  packet.mincost[0] = 3;
  packet.mincost[1] = 1;
  packet.mincost[2] = 0;
  packet.mincost[3] = 2;
  tolayer2(packet);
  packet.destid = 1;
  tolayer2(packet);
  packet.destid = 3;
  tolayer2(packet);
  dtptr = &dt2;
  printdt2(dtptr);
}

void rtupdate2(rcvdpkt)
  struct rtpkt *rcvdpkt;
  
{
  struct rtpkt packet;
  struct distance_table *dtptr;
  int min = 0;

  if (rcvdpkt->sourceid == 0)
  {
    if (rcvdpkt->mincost[1] != 0)
    {
      dt2.costs[0][1] = dt2.costs[1][1] + rcvdpkt->mincost[1];
      dt2.costs[1][0] = dt2.costs[0][0] + rcvdpkt->mincost[1];
    }
    if (rcvdpkt->mincost[3] != 0)
    {
      dt2.costs[0][3] = dt2.costs[3][3] + rcvdpkt->mincost[3];
          dt2.costs[3][0] = dt2.costs[0][0] + rcvdpkt->mincost[3];
    }
  }

  if (rcvdpkt->sourceid == 1)
  {
    if (rcvdpkt->mincost[0] != 0)
    {
      dt2.costs[0][1] = dt2.costs[1][1] + rcvdpkt->mincost[0];
      dt2.costs[1][0] = dt2.costs[0][0] + rcvdpkt->mincost[0];
    }
    if (rcvdpkt->mincost[3] != 0)
    {
      dt2.costs[1][3] = dt2.costs[3][3] + rcvdpkt->mincost[3];
          dt2.costs[3][1] = dt2.costs[1][1] + rcvdpkt->mincost[3];
    }
  }

  if (rcvdpkt->sourceid == 3)
  {
    if (rcvdpkt->mincost[0] != 0)
    {
      dt2.costs[0][3] = dt2.costs[3][3] + rcvdpkt->mincost[0];
      dt2.costs[3][0] = dt2.costs[0][0] + rcvdpkt->mincost[0];
    }
    if (rcvdpkt->mincost[1] != 0)
    {
      dt2.costs[1][3] = dt2.costs[3][3] + rcvdpkt->mincost[1];
          dt2.costs[3][1] = dt2.costs[1][1] + rcvdpkt->mincost[1];
    }
  }
  
  min = (dt2.costs[0][0] < dt2.costs[0][1]) ? (dt2.costs[0][0]) : (dt2.costs[0][1]);
  min = (min < dt2.costs[0][3]) ? (min) : (dt2.costs[0][3]);

  if (min != stored_mincost[0])
  {
    packet.mincost[0] = min;
    stored_mincost[0] = min;
        update_flag = 1;
  }
  else
  {
        packet.mincost[0] = 0;
  }
  min = (dt2.costs[1][0] < dt2.costs[1][1]) ? (dt2.costs[1][0]) : (dt2.costs[1][1]);
  min = (min < dt2.costs[1][3]) ? (min) : (dt2.costs[1][3]);

  if (min != stored_mincost[1])
  {
    packet.mincost[1] = min;
    stored_mincost[1] = min;    
    update_flag = 1;
  }
  else
  {
        packet.mincost[1] = 0;
  }
  min = (dt2.costs[3][0] < dt2.costs[3][1]) ? (dt2.costs[3][0]) : (dt2.costs[3][1]);
  min = (min < dt2.costs[3][3]) ? (min) : (dt2.costs[3][3]);

  if (min != stored_mincost[3])
  {
    packet.mincost[3] = min;
    stored_mincost[3] = min;
        update_flag = 1;
  }
  else
  {
        packet.mincost[3] = 0;
  }
  
  if (update_flag == 1)
  {
        packet.mincost[2] = 0;
        packet.sourceid = 2;
        packet.destid = 0;
        tolayer2(packet);
        packet.destid = 1;
        tolayer2(packet);
        packet.destid = 3;
        tolayer2(packet);
        update_flag = 0;
  }
  dtptr = &dt2;
  printdt2(dtptr);
}


printdt2(dtptr)
  struct distance_table *dtptr;
  
{
  printf("                via     \n");
  printf("   D2 |    0     1    3 \n");
  printf("  ----|-----------------\n");
  printf("     0|  %3d   %3d   %3d\n",dtptr->costs[0][0],
         dtptr->costs[0][1],dtptr->costs[0][3]);
  printf("dest 1|  %3d   %3d   %3d\n",dtptr->costs[1][0],
         dtptr->costs[1][1],dtptr->costs[1][3]);
  printf("     3|  %3d   %3d   %3d\n",dtptr->costs[3][0],
         dtptr->costs[3][1],dtptr->costs[3][3]);
}







